"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.CustomOptionsReader = void 0;
const path = require("path");
class CustomOptionsReader {
    constructor() {
        this.priority = 900;
        this.name = 'custom-options';
    }
    read(container, logger) {
        const options = this.getOptionsFile(path.resolve(path.join(container.getValue('theme'), 'options.js')));
        if (options) {
            Object.entries(options).forEach(([key, value]) => {
                container.setValue(key, value);
            });
        }
    }
    getOptionsFile(optionsFile) {
        try {
            return require(optionsFile).default;
        }
        catch (e) {
            return null;
        }
    }
}
exports.CustomOptionsReader = CustomOptionsReader;
